local inf_hp = true
local fixed_hp_for_dragonheart = false
local cancel_overheal_for_dragonheart = false
local set_hp_for_dragonheart = false
local inf_redgauge = false
local dragonheartSkillId = 103

local function _getDragonheartSkillHpPercent()
	local manager = sdk.get_managed_singleton("snow.player.PlayerManager")
	if not manager then 
		return 1.0
	end
	local player = manager:call("findMasterPlayer")
    if not player then 
        return 1.0
    end
	local playerSkills = player:call("get_PlayerSkillList")
	if not playerSkills then
		return 1.0
	end
	local skill = playerSkills:call("getSkillData", dragonheartSkillId)
	if skill then
		local skillLv = skill:get_field("SkillLv")
		if (skillLv == 1) or (skillLv == 2) then
			return 0.5
		elseif (skillLv == 3) or (skillLv == 4) then
			return 0.7
		elseif (skillLv == 5) then
			return 0.8
		end
	end
	return 1.0
end

local function on_do_update(args)
	local playerData = sdk.get_managed_singleton("snow.player.PlayerManager"):call("findMasterPlayer"):call("get_PlayerData")

	if inf_hp then
		local maxHP = playerData:get_field("_vitalMax")
		playerData:set_field("_r_Vital",maxHP)
		playerData:call("set__vital" , maxHP)
	end
	if set_hp_for_dragonheart or fixed_hp_for_dragonheart then
		local maxHP = playerData:get_field("_vitalMax")
		local hpRate = _getDragonheartSkillHpPercent()
		local setHpValue = math.floor(maxHP * hpRate)
		if inf_redgauge then
			setHpValue = setHpValue - 5
		end
		playerData:set_field("_r_Vital",setHpValue)
		playerData:call("set__vital" , setHpValue)
		if set_hp_for_dragonheart then
			set_hp_for_dragonheart = false
		end
	end
	if cancel_overheal_for_dragonheart then
		local maxHP = playerData:get_field("_vitalMax")
		local nowHP = playerData:call("get__vital")
		local rHP = playerData:get_field("_r_Vital")
		local hpRate = _getDragonheartSkillHpPercent()
		local setHpValue = math.floor(maxHP * hpRate)
		if inf_redgauge then
			setHpValue = setHpValue - 5
		end
		if nowHP > setHpValue then
			playerData:call("set__vital" , setHpValue)
		end
		if rHP > setHpValue then
			playerData:set_field("_r_Vital",setHpValue)
		end
	end
	if inf_redgauge then
		local maxHP = playerData:get_field("_vitalMax")
		playerData:set_field("_r_Vital",maxHP)
	end
end

sdk.hook(
   sdk.find_type_definition("snow.player.PlayerManager"):get_method("update"), 
   on_do_update, 
    function(retval) end)

re.on_draw_ui(function()
	local changed = false
	
	if imgui.tree_node("Inf HP") then   
		changed, inf_hp = imgui.checkbox("Enable Inf HP", inf_hp)
		changed, fixed_hp_for_dragonheart = imgui.checkbox("Fixed HP for Drugonheart", fixed_hp_for_dragonheart)
		changed, cancel_overheal_for_dragonheart = imgui.checkbox("Cancel Overheal(for Drugonheart)", cancel_overheal_for_dragonheart)
		changed, inf_redgauge = imgui.checkbox("Enable Inf RedGauge", inf_redgauge)
		changed, set_hp_for_dragonheart = imgui.checkbox("Set HP for Drugonheart", set_hp_for_dragonheart)
	end 
end)